#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include <stdbool.h>
#include <time.h>

#define WINDOW_WIDTH 800
#define WINDOW_HEIGHT 600

/* vytvorte strukturu reprezentujici pohybujici se atom (SDL_rect a rychlosti ve smeru x,y) */
typedef struct
{
  
} Atom;


/* vytvorte funkci, ktera vytvori a vrati atom na vybrane pozici, o vybrane velikosti a s vybranym vektorem rychlosti */
Atom* atom_create(int pos_x, int pos_y, int r, int speed_x, int speed_y)
{
    Atom* a = (Atom*) malloc(sizeof(Atom));
    return a;
}

void atom_delete(Atom* a)
{
    free(a);
}

/* vytvorte funkci, ktera pohne s atomem o vektor rychlosti. Pokud je atom na okraji platna, odrazi se od steny */
void atom_move(Atom* a)
{
    
}

/* vytvorte funkci, ktera zvysi rychlost atomu */
void atom_increase_speed(Atom* a)
{
   
}

/* vytvorte funkci, ktera snizi rychlost atomu (az do 0, kdy se zastavi) */
void atom_decrease_speed(Atom* a)
{
   
}

int main()
{
    srand(time(NULL));

    if (SDL_Init(SDL_INIT_VIDEO)) {
        fprintf(stderr, "SDL_Init Error: %s\n", SDL_GetError());
        return 1;
    }
    SDL_Window* win = SDL_CreateWindow("SDL experiments", 100, 100, WINDOW_WIDTH, WINDOW_HEIGHT, SDL_WINDOW_SHOWN);
    if (!win) {
        fprintf(stderr, "SDL_CreateWindow Error: %s\n", SDL_GetError());
        SDL_Quit();
        return 1;
    }

    SDL_Renderer* ren = SDL_CreateRenderer(win, -1, SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC);
    if (!ren) {
        SDL_DestroyWindow(win);
        fprintf(stderr, "SDL_CreateRenderer Error: %s", SDL_GetError()); 
        SDL_Quit();
        return 1;
    }
    
    /* nacteme obrazek do textury, kterou pak pouzijeme na rectangle */
    SDL_Surface* img = IMG_Load("atom.svg");
    if(!img)
    {
        fprintf(stderr, "SDL_IMG_Load Error: %s", SDL_GetError()); 
        SDL_Quit();
        return 1;
    }

    SDL_Texture* texture = SDL_CreateTextureFromSurface(ren, img);
    if(!texture)
    {
        fprintf(stderr, "SDL_CreateTextureFromSurface Error: %s", SDL_GetError()); 
        SDL_Quit();
        return 1;
    }
    
    SDL_FreeSurface(img);


    SDL_Event e;

    /* vygenerujte nahodna cisla pro pozici, velikost a rychlost atomu */
    int rnd_r = 0;
    int rnd_x = 0;
    int rnd_y = 0;
    int rnd_sx = 0;
    int rnd_sy = 0;

    //Atom* a = atom_create(rnd_x, rnd_y, rnd_r, rnd_sx, rnd_sy);

    
    SDL_Rect rect;
    rect.x = 50;
    rect.y = 50;
    rect.w = 100;
    rect.h = 60;
    int speed_x = 5;

    bool quit = false;
    while (!quit)
    {
        while (SDL_PollEvent(&e))
        {
            if (e.type == SDL_QUIT)
            {
                quit = true;
            }
            else if (e.type == SDL_KEYDOWN) // stisknuti klavesy
            {
                if (e.key.keysym.sym == SDLK_r)
                {
                    quit = true;
                }

                if (e.key.keysym.sym == SDLK_KP_PLUS)
                {
                    //atom_increase_speed(a);
                }
                if (e.key.keysym.sym == SDLK_KP_MINUS)
                {
                    //atom_decrease_speed(a);
                }
            }
            else if (e.type == SDL_MOUSEBUTTONUP && e.button.button == SDL_BUTTON_LEFT) // stisknuti tlacitka mysi
            {
                // x: e.button.button.x
                // y: e.button.button.y
            }
            else if (e.type == SDL_MOUSEMOTION) // pohyb mysi
            {
                // x: e.motion.x
                // y: e.motion.y
            }
        }

        SDL_SetRenderDrawColor(ren, 0, 0, 0, 255);
        SDL_RenderClear(ren);

        if (rect.x + rect.w >= WINDOW_WIDTH || rect.x <= 0)
        {
            speed_x *= -1;
        }

        SDL_SetRenderDrawColor(ren, 255, 0, 0, 255);
        SDL_RenderFillRect(ren, &rect);
        rect.x += speed_x;
        
        //SDL_RenderCopy(ren, texture, NULL, &(a->rect));
        //atom_move(a);
        

        SDL_RenderPresent(ren);

    }
    
    //atom_delete(a);
    SDL_DestroyTexture(texture);

    SDL_DestroyRenderer(ren);
    SDL_DestroyWindow(win);

    IMG_Quit();
    SDL_Quit();

    return 0;
}
